from django.db.models.signals import post_save,pre_save

from django.dispatch import receiver
from .models import *
from wagtail.signals import page_published

# Copy OS & Family Name for App Items
from wagtail.images.models import Image
import re

# @receiver(post_save, sender=Image)
# def update_image_desc(sender, instance,created, **kwargs):
#     print("OKKKKK=",created)
#     if created:
#         print("Created=",instance.id)
#     else:
#         print("Not Created=",instance.id)
#         img=Image.objects.get(id=instance.id)
#         img.description=img.title
#         img.save()
    # string=instance.file.name
    # rx_to_first = r'^.*?{}'.format(re.escape("/"))
    # str1=re.sub(rx_to_first, '', string, flags=re.DOTALL).strip()
    # head, sep, tail = str1.partition('.')
    # print("Head=",head)
    # print("sep=",sep)
    # print("tail=",tail)
    # instance.description = str(head)
    # instance.save()
    # pass
            
            
@receiver(pre_save, sender=Company)
def com_alias(sender, instance, **kwargs):
    instance.alias = instance.coName.replace(' ', '_').lower()

@receiver(post_save, sender=ProductType)
def update_attributes(sender, instance, **kwargs):
    subCat=instance.cat
    products=ProductPage.objects.filter(subCat=subCat)
    for prod in products:
        if prod.prod_attr_values.all().count() == 0:
            pavList = []
            for pa in ProductAttributes.objects.filter(type__cat__name=subCat):
                pavList.append(ProductAttributeValue(attribute=pa))
            prod.prod_attr_values = pavList
            prod.save()      
        else:
            NewpavList = []
            for pa in ProductAttributes.objects.filter(type__cat__name=subCat):
                if prod.prod_attr_values.filter(attribute=pa).exists():
                    NewpavList.append(prod.prod_attr_values.get(attribute=pa))
                else:
                    NewpavList.append(ProductAttributeValue(attribute=pa))
            prod.prod_attr_values = NewpavList
            prod.save()
        for proVar in prod.get_children():
            if proVar.specific.prod_var_attr_values.all().count() == 0:
                pavList = []
                for pa in ProductAttributes.objects.filter(type__cat__name=subCat):
                    pavList.append(ProductVariantAttributeValue(attribute=pa))
                proVar.specific.prod_var_attr_values = pavList
                proVar.specific.save()
            else:
                NewpavList = []
                for pa in ProductAttributes.objects.filter(type__cat__name=subCat):
                    if proVar.specific.prod_var_attr_values.filter(attribute=pa).exists():
                        NewpavList.append(proVar.specific.prod_var_attr_values.get(attribute=pa))
                    else:
                        NewpavList.append(ProductVariantAttributeValue(attribute=pa))
                proVar.specific.prod_var_attr_values = NewpavList
                proVar.specific.save() 
        
        
    

@receiver(pre_save, sender=AppItems)
def update_apps_item(sender, instance, **kwargs):
    if instance.osName == None:
        instance.osName = instance.app.series
        instance.save()
    if instance.osfamily == None:
        instance.osfamily = instance.app.family
        instance.save()
        
        
        
# Add Attributes for Product
@receiver(page_published, sender=ProductPage)
def update_product(sender, instance, **kwargs):
    if instance.seo_title == "":
        from bs4 import BeautifulSoup
        soup = BeautifulSoup(instance.customTitle)
        instance.seo_title=soup.get_text()
        instance.search_description=soup.get_text()
        instance.save()
    if instance.bannercontent:
        for block in instance.bannercontent:
            if block.block_type == 'slide':
                if block.value['title'] == "":
                    block.value['title']=block.value['image'].title
        instance.save()
        
    prType = instance.subCat
    if instance.prod_attr_values.all().count() == 0:
        pavList = []
        for pa in ProductAttributes.objects.filter(type__cat__name=prType):
            pavList.append(ProductAttributeValue(attribute=pa))
        instance.prod_attr_values = pavList
        instance.save()      
    else:
        NewpavList = []
        for pa in ProductAttributes.objects.filter(type__cat__name=prType):
            if instance.prod_attr_values.filter(attribute=pa).exists():
                NewpavList.append(instance.prod_attr_values.get(attribute=pa))
            else:
                NewpavList.append(ProductAttributeValue(attribute=pa))
        instance.prod_attr_values = NewpavList
        instance.save()      
        
   
# Add Attributes for Product Variant
@receiver(page_published, sender=ProductVariantPage)  
def update_product_variant(sender, instance, **kwargs):
    if instance.seo_title == "":
        from bs4 import BeautifulSoup
        soup = BeautifulSoup(instance.customTitle)
        instance.seo_title=soup.get_text()
        instance.search_description=soup.get_text()
        instance.save()
    if instance.bannercontent:
        for block in instance.bannercontent:
            if block.block_type == 'slide':
                if block.value['title'] == "":
                    block.value['title']=block.value['image'].title
        instance.save()
        
    prType = instance.get_parent().specific.subCat
    if instance.prod_var_attr_values.all().count() == 0:
        pavList = []
        for pa in ProductAttributes.objects.filter(type__cat__name=prType):
            pavList.append(ProductVariantAttributeValue(attribute=pa))
        instance.prod_var_attr_values = pavList
        instance.save()
    else:
        NewpavList = []
        for pa in ProductAttributes.objects.filter(type__cat__name=prType):
            if instance.prod_var_attr_values.filter(attribute=pa).exists():
                NewpavList.append(instance.prod_var_attr_values.get(attribute=pa))
            else:
                NewpavList.append(ProductVariantAttributeValue(attribute=pa))
        instance.prod_var_attr_values = NewpavList
        instance.save()      
        
       
